﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.01
@EndOfDesignText@
#Event: ItemClick (Place As PlaceData)
#DesignerProperty: Key: HighlightColor, DisplayName: Highlight Color, FieldType: Color, DefaultValue: 0xFFFD5C5C
#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: Null
'Class module
Sub Class_Globals
	Private et As EditText
	Private lv As ListView
	Private mCallback As Object
	Private mEventName As String
	Private mBase As Panel
	Private ime As IME
	Private maxHeight As Int
	Private highlightColor As Int = 0xFFFD5C5C
	Private Const DefaultColorConstant As Int = -984833 'ignore
	Private QueryIndexSent, QueryIndexReceived As Int
	Type PlaceData (Description As String, Id As String)
	Private lblX As Label
End Sub

Public Sub Initialize (vCallback As Object, vEventName As String)
	'lv.Initialize("lv")
	mEventName = vEventName
	mCallback = vCallback
	et.Initialize("et")
	
	Dim cd As ColorDrawable
	cd.Initialize2(Colors.ARGB(180,255,255,255),5dip,2dip,Colors.RGB(233,233,233))
	
	et.Background = cd
	et.Hint = "Cerca il luogo di stage"
	et.HintColor = Colors.Gray
	et.SingleLine = True
	
	'Remove the suggestions bar
	et.InputType = Bit.Or(et.INPUT_TYPE_TEXT, 0x00080000)
	lv.Initialize("lv")
	lv.SingleLineLayout.ItemHeight = 50dip
	lv.SingleLineLayout.Label.TextSize = 15
	lv.SingleLineLayout.Label.Typeface = Typeface.DEFAULT_BOLD
	lv.Visible = False
	ime.Initialize("")
	
'	Dim jo As JavaObject = lv
'	jo.GetFieldJO("vp").RunMethod("setOverScrollMode", Array(2))
'
End Sub

Public Sub DesignerCreateView (Base As Panel, lbl As Label, Props As Map)
	mBase = Base
	mBase.AddView(et, 0, 0, mBase.Width, 60dip)
	mBase.AddView(lv, 0, et.Height, mBase.Width, mBase.Height - et.Height)
	mBase.Color = Colors.Transparent

	lblX.Initialize("lblX")
	lblX.Typeface = Typeface.MATERIALICONS
	lblX.Text = Chr(0xE5CD) 'Caratttere della X per cancellare
	lblX.TextSize = 28
	lblX.TextColor = Colors.Gray
	lblX.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, Gravity.RIGHT)
	
	mBase.AddView(lblX, mBase.Width - 40dip, 15dip, 30dip, 30dip)
	maxHeight = mBase.Height
	highlightColor = Props.Get("HighlightColor")
	
	Dim c As Int = Props.Get("TextColor")
	If c <> DefaultColorConstant Then 
		lv.SingleLineLayout.Label.TextColor = c
		et.TextColor = c
	End If
End Sub

Private Sub lblX_Click
	Dim a3 As Animation
	
	a3.InitializeScaleCenter("1",1,1,0,0,lblX)
	
	a3.Duration = 100
	
	a3.Start(lblX)	
	
	Sleep(100)
	a3.Stop(lblX)
	
	a3.InitializeScaleCenter("",0,0,1,1,lblX)
	
	a3.Duration = 100
	
	a3.Start(lblX)
	Sleep(100)
	a3.Stop(lblX)
	
End Sub

Public Sub ActivityHeightChanged(NewHeight As Int)
	Dim baseHeight As Int = Min(maxHeight, NewHeight - mBase.Top)
	mBase.SetLayout(mBase.Left, mBase.Top, mBase.Width, baseHeight)
	lv.SetLayout(0, lv.Top, lv.Width, baseHeight - lv.Top)
End Sub


Private Sub lv_ItemClick (Position As Int, Value As Object)
	Dim pd As PlaceData = Value
	et.Text = pd.Description
	et.SelectionStart = et.Text.Length
	ime.HideKeyboard
	lv.Visible = False
	If SubExists(mCallback, mEventName & "_ItemClick") Then
		CallSub2(mCallback, mEventName & "_ItemClick", Value)
	End If
End Sub

Private Sub et_TextChanged (Old As String, New As String)
	If (New.Length = 0) Then
		lv.Clear
		lv.Visible = False
	Else
		If lv.Visible = False Then lv.Visible = True
		Dim j As HttpJob
		
		j.Initialize("", Me)
		j.Download2("https://maps.googleapis.com/maps/api/place/autocomplete/json", _
			Array As String("input", New, "type", "establishment", "location", "45.156389,10.791440","radius",1000, "key", Main.GoogleApiKey)) 'Modificare questa stringa per PARAMETRI aggiuntivi
		QueryIndexSent = QueryIndexSent + 1
		Dim index As Int = QueryIndexSent
		Wait For (j) JobDone (j As HttpJob)
		
		If j.Success Then
			If QueryIndexReceived > index Then
				Return
			Else
				Dim pds As List
				pds.Initialize
				lv.Clear
				QueryIndexReceived = index
				Dim jp As JSONParser
				jp.Initialize(j.GetString)
				Dim m As Map = jp.NextObject
				Dim predictions As List = m.Get("predictions")
				For Each pred As Map In predictions
					Dim pd As PlaceData
					pd.Initialize
					pd.Id = pred.Get("place_id")
					pd.Description = pred.Get("description")
					pds.Add(pd)
				Next
				AddItemsToList(pds, New.ToLowerCase)
			End If
		End If
		j.Release
	End If
End Sub

Private Sub AddItemsToList(li As List, full As String)
	If li.IsInitialized = False Then Return
	Dim cs As CSBuilder
	For Each Item As PlaceData In li
		Dim desc As String = Item.Description
		Dim x As Int = desc.ToLowerCase.IndexOf(full)
		If x = -1 Then
			Continue
		End If
		cs.Initialize.Append(desc.SubString2(0, x)).Color(highlightColor).Append(desc.SubString2(x, x + full.Length)).Pop
		cs.Append(desc.SubString(x + full.Length))
		lv.AddSingleLine2(cs, Item)
	Next
End Sub

